//copyright delfare <http://delfare.pizz.biz>
#include <PA9.h> 

#include "bitmap/all_gfx.c" // Include the picture...
#include "bitmap/all_gfx.h" // Include the picture...


#include "collision_snd_raw.h"
	int collision_snd_ch=15;
	int collision_snd_vol=127;

#include "score_snd_raw.h"
	int score_snd_ch=14;
	int score_snd_vol=127;

#include "tunneli_pcx.h"
#include "tunneli2_pcx.h"
#include "tunneli3_pcx.h"
#include "tunneli4_pcx.h"
#include "euro_pcx.h"
#include "finished_pcx.h"

#include "dancetus_mod.h"


int tunnelitex;
int eurotex;
int finishedtex;


int window_height=256;
int window_width=192;
float cur_time,last_time;
int level_num;

	typedef struct
	{
		float x,y,z;
		float 	score;
	
	}tsPlayer;
	tsPlayer player;
	
		float t_x;
		float t_y;
	
	bool mousedown;
	
	typedef struct
	{
		float x,y;
	
	}tsVertex;
	
	typedef struct
	{
		tsVertex 	free_place[512];
		bool	 	coin[512];
	}tsLevel;
	tsLevel level1;
	
	bool collision=0;
	

	#include "demo.h"
	#include "GenLevels.h"
	#include "draw.h"
	#include "controls.h"
	
	
	
	
int main()
{
	PA_Init();
	PA_InitVBL();	
	PA_InitSound();
	
	
	
	u8 timmy=NewTimer(1);
	StartTime(1);
	StartTimer(timmy);
	
		player.x=0;
		player.y=0;
		player.z=0;
		

	// splash
	PA_Init8bitBg(1, 3);
	PA_LoadPal(PAL_BG1, tassumap_Pal);
	PA_Load8bitBitmap(1, tassu_Bitmap)
	
	PA_Init8bitBg(0, 3);
	PA_LoadPal(PAL_BG0, instructionsmap_Pal);
	PA_Load8bitBitmap(0, instructions_Bitmap)
	
	PA_PlayMod(dancetus_mod);
	
	bool done_title=0;
	float a1=-30;
	float a0=-30;	
	while(!done_title) 
	{		
		if(a1<0)
		{
			a1+=0.2;
			if(Pad.Released.Start || Stylus.Held)
			{
				a1=0;a0=0;
			}
		}
		else
		{
			if(a0<0)
			{
				a0+=0.2;
				if(Pad.Released.Start || Stylus.Held)
				{
					a1=0;a0=0;
				}
			}
			else
			{
				if(Pad.Released.Start || Stylus.Held)
					done_title=1;
			}
		}
		
		
		PA_SetBrightness(1,a1);
		PA_SetBrightness(0,a0);

		glFlush();
		PA_WaitForVBL();
	}
	PA_StopMod();

	// game
	PA_Init3D();
	
	PA_LoadSpritePal(1, // Screen
					0, // Palette number
					(void*)cursor_Pal);
	PA_CreateSprite(1, 0,(void*)cursor_Sprite, OBJ_SIZE_32X32,1, 0, 0, 0);
	PA_SetSpriteXY(1,0,256/2-16,192/2-16);
	PA_SetSpriteRotEnable(1,// screen
						0,// sprite number
						0);// rotset?

	PA_Init8bitBg(1, 3);
	PA_LoadPal(PAL_BG1, drawscreenmap_Pal);
	PA_Load8bitBitmap(1, drawscreen_Bitmap)	
	
	PA_SetBrightness(1,0);
	
	PA_SwitchScreens();

	float bright=-30;
	
	SetCoins();
	GenLevel();	
	
	PA_PlayMod(dancetus_mod);
	
	while(1) 
	{
		if(bright<0)
			bright+=1;
	
		PA_SetBrightness(0,(int)bright);
		PA_SetBrightness(1,(int)bright);
		///////////////////////////////
		
		cur_time=(float)Tick(timmy)/2;
		UpdateStuff();
		ButtonsControl();

		DrawStuff();
		DrawParts();

		glFlush();
		PA_WaitForVBL();
		
		
		// finished
		if(player.z>505)
		{
			PA_DeleteSprite(1,0);
		
			glResetTextures();
			finishedtex=tsLoadPCX((u8*)finished_pcx,1);
	
			bright=-30;
			
			float per=(79-29.5)*(player.score/(512/7));
			float per2=0;
			
			
			while(!Pad.Released.Start)
			{
				PA_Init3DDrawing(0.0,0.0,1.0,//x,y,z
				0.0,0.0,0.0);//eyex, eyey, eyez
				
				if(bright<0)
					bright+=1;
			
				PA_SetBrightness(0,(int)bright);
				PA_SetBrightness(1,(int)bright);
				
				// finished screen background
					glLoadIdentity();
					glTranslatef(0,0,-2);
					PA_Texture(finishedtex);
					glColor3f(1,1,1);
					glRotatef(90,0,0,1);
					glBegin(GL_QUAD);
						glTexCoord2f(0.0f,0.0f); glVertex3f(-1.33f, -2.0f,  0.0f);
						glTexCoord2f(1.0f,0.0f); glVertex3f( 1.33f, -2.0f,  0.0f);
						glTexCoord2f(1.0f,2.0f); glVertex3f( 1.33f,  2.0f,  0.0f);
						glTexCoord2f(0.0f,2.0f); glVertex3f(-1.33f,  2.0f,  0.0f);
					glEnd();
				
				glTranslatef(0,0,0.01);
				
				
				// score bar
					float width=4;
					float height=2.66;
					
					if(per2<per && bright>=0)
					{
						per2+=1;
						PA_PlaySimpleSound(score_snd_ch, score_snd_raw);
						SndChgVolume(score_snd_ch, 30);
					}
					
					float h1=-height/2+(height/100*70);
					float h2=-height/2+(height/100*78);
					float w1=-width/2+(width/100*29.5);
					float w2=-width/2+(width/100*(29.5+per2));
					
					PA_Texture(0);
					
					glBegin(GL_QUAD);
						glTexCoord2f(0.0f,0.0f); glVertex3f(h1, w1,  0.0f);
						glTexCoord2f(1.0f,0.0f); glVertex3f(h2, w1,  0.0f);
						glTexCoord2f(1.0f,1.0f); glVertex3f(h2, w2,  0.0f);
						glTexCoord2f(0.0f,1.0f); glVertex3f(h1, w2,  0.0f);
					glEnd();
					
					glFlush();
					PA_WaitForVBL();
			}
			

			// reinit game	
			bright=-30;		
			PA_SetBrightness(0,(int)bright);
			PA_SetBrightness(1,(int)bright);
			PA_WaitForVBL();
				
			PA_Clear8bitBg(1);
			PA_LoadPal(PAL_BG1, drawscreenmap_Pal);
			PA_Load8bitBitmap(1, drawscreen_Bitmap)
			SetCoins();
			GenLevel();
			
			PA_PlayMod(dancetus_mod);
			
			
			PA_CreateSprite(1, 0,(void*)cursor_Sprite, OBJ_SIZE_32X32,1, 0, 0, 0);
			PA_SetSpriteXY(1,0,256/2-16,192/2-16);
			PA_SetSpriteRotEnable(1,0,0);
			
		}
		
	}
	return 1;
}

