#include <stdlib.h>
#include <math.h>


int tsLoadPCX(u8 *img_pcx, bool bigger)
{
	int texnum;
	sImage pcx;


	loadPCX((u8*)img_pcx, &pcx);
	
	image8to16(&pcx);

	glGenTextures(1, &texnum);
	glBindTexture(0, texnum);
	if(bigger)
		glTexImage2D(GL_TEXTURE_2D, 0, GL_RGB, TEXTURE_SIZE_256 , TEXTURE_SIZE_128, 0, TEXGEN_TEXCOORD, pcx.data8);
	else
		glTexImage2D(GL_TEXTURE_2D, 0, GL_RGB, TEXTURE_SIZE_64 , TEXTURE_SIZE_64, 0, TEXGEN_TEXCOORD, pcx.data8);

	imageDestroy(&pcx);

	return texnum;
}
